// -*- C++ -*- generated by wxGlade 0.6.3

#include "DialogSettings.h"

// begin wxGlade: ::extracode

// end wxGlade


DialogSettings::DialogSettings(wxWindow* parent, int id, const wxString& title, const wxPoint& pos, const wxSize& size, long style):
    wxDialog(parent, id, title, pos, size, wxDEFAULT_DIALOG_STYLE)
{
    // begin wxGlade: DialogSettings::DialogSettings
    notebook_settings = new wxNotebook(this, wxID_ANY, wxDefaultPosition, wxDefaultSize, 0);
    notebook_settings_pane_logging = new wxPanel(notebook_settings, wxID_ANY);
    notebook_settings_pane_encodings = new wxPanel(notebook_settings, wxID_ANY);
    notebook_settings_pane_conn = new wxPanel(notebook_settings, wxID_ANY);
    sizer_qos_staticbox = new wxStaticBox(notebook_settings_pane_conn, -1, _("Quality of Service"));
    sizer_multicast_staticbox = new wxStaticBox(notebook_settings_pane_conn, -1, _("MulticastVNC"));
    sizer_encbox_staticbox = new wxStaticBox(notebook_settings_pane_encodings, -1, _("Enabled Encodings"));
    sizer_tightsettings_staticbox = new wxStaticBox(notebook_settings_pane_encodings, -1, _("Lossy Encodings Settings"));
    sizer_fastrequest_staticbox = new wxStaticBox(notebook_settings_pane_conn, -1, _("FastRequest"));
    checkbox_fastrequest = new wxCheckBox(notebook_settings_pane_conn, wxID_ANY, _("Enable FastRequest"));
    label_fastrequest = new wxStaticText(notebook_settings_pane_conn, wxID_ANY, _("Continously request updates at the specified milisecond interval:"));
    slider_fastrequest = new wxSlider(notebook_settings_pane_conn, wxID_ANY, 0, 1, 100, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL|wxSL_AUTOTICKS|wxSL_LABELS);
    checkbox_qos_ef = new wxCheckBox(notebook_settings_pane_conn, wxID_ANY, _("Enable Expedited Forwarding tagging for sent data"));
    checkbox_multicast = new wxCheckBox(notebook_settings_pane_conn, wxID_ANY, _("Enable MulticastVNC"));
    label_socketrecvbuf = new wxStaticText(notebook_settings_pane_conn, wxID_ANY, _("Socket Receive Buffer Size (kB):"));
    slider_socketrecvbuf = new wxSlider(notebook_settings_pane_conn, wxID_ANY, 0, 65, 9750, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL|wxSL_LABELS);
    label_recvbuf = new wxStaticText(notebook_settings_pane_conn, wxID_ANY, _("Receive Buffer Size (kB):"));
    slider_recvbuf = new wxSlider(notebook_settings_pane_conn, wxID_ANY, 0, 65, 9750, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL|wxSL_LABELS);
    checkbox_enc_copyrect = new wxCheckBox(notebook_settings_pane_encodings, wxID_ANY, _("CopyRect"));
    checkbox_enc_hextile = new wxCheckBox(notebook_settings_pane_encodings, wxID_ANY, _("Hextile"));
    checkbox_enc_rre = new wxCheckBox(notebook_settings_pane_encodings, wxID_ANY, _("RRE"));
    checkbox_enc_corre = new wxCheckBox(notebook_settings_pane_encodings, wxID_ANY, _("CoRRE"));
    checkbox_enc_zlib = new wxCheckBox(notebook_settings_pane_encodings, wxID_ANY, _("Zlib"));
    checkbox_enc_zlibhex = new wxCheckBox(notebook_settings_pane_encodings, wxID_ANY, _("ZlibHex"));
    checkbox_enc_zrle = new wxCheckBox(notebook_settings_pane_encodings, wxID_ANY, _("ZRLE"));
    checkbox_enc_zywrle = new wxCheckBox(notebook_settings_pane_encodings, wxID_ANY, _("ZYWRLE"));
    checkbox_enc_ultra = new wxCheckBox(notebook_settings_pane_encodings, wxID_ANY, _("Ultra"));
    checkbox_enc_tight = new wxCheckBox(notebook_settings_pane_encodings, wxID_ANY, _("Tight"));
    label_compresslevel = new wxStaticText(notebook_settings_pane_encodings, wxID_ANY, _("Compression level for 'Tight' and 'Zlib' encodings:"));
    slider_compresslevel = new wxSlider(notebook_settings_pane_encodings, wxID_ANY, 0, 0, 9, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL|wxSL_AUTOTICKS|wxSL_LABELS);
    label_quality = new wxStaticText(notebook_settings_pane_encodings, wxID_ANY, _("Quality level for 'Tight' and 'ZYWRLE' encoding:"));
    slider_quality = new wxSlider(notebook_settings_pane_encodings, wxID_ANY, 0, 0, 9, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL|wxSL_AUTOTICKS|wxSL_LABELS);
    checkbox_logfile = new wxCheckBox(notebook_settings_pane_logging, wxID_ANY, _("Write VNC log to logfile (MultiVNC.log)"));
    checkbox_stats_save = new wxCheckBox(notebook_settings_pane_logging, wxID_ANY, _("Autosave statistics on close"));

    set_properties();
    do_layout();
    // end wxGlade
}


void DialogSettings::set_properties()
{
    // begin wxGlade: DialogSettings::set_properties
    slider_fastrequest->SetToolTip(_("Continously ask the server for updates instead of just asking after each received server message. Use this on high latency links."));
    slider_socketrecvbuf->SetToolTip(_("Set the multicast socket receive buffer size. Increasing the value may help against packet loss. Note that the maximum value is operating system dependent."));
    slider_recvbuf->SetToolTip(_("Set the multicast receive buffer size. Increasing the value may help against packet loss. The size of this buffer is independent of the operating system."));
    slider_compresslevel->SetToolTip(_("Use specified compression level (0..9) for 'Tight' and 'Zlib' encodings. Level 1 uses minimum of CPU time and achieves weak compression ratios, while level 9 offers best compression but is slow in terms of CPU time consumption on the server side. Use high levels with very slow network connections, and low levels when working over high-speed LANs."));
    slider_quality->SetToolTip(_("Use the specified quality level (0..9) for the 'Tight' and 'ZYWRLE' encodings. Quality level 0 denotes bad image quality but very impressive compression ratios, while level 9 offers very good image quality at lower compression ratios. Note that the \"tight\" encoder uses JPEG to encode only those screen areas that look suitable for lossy compression, so quality level 0 does not always mean unacceptable image quality."));
    // end wxGlade
}


void DialogSettings::do_layout()
{
    // begin wxGlade: DialogSettings::do_layout
    wxBoxSizer* sizer_top = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* sizer_logging = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* sizer_encodings = new wxBoxSizer(wxVERTICAL);
    wxStaticBoxSizer* sizer_tightsettings = new wxStaticBoxSizer(sizer_tightsettings_staticbox, wxVERTICAL);
    wxStaticBoxSizer* sizer_encbox = new wxStaticBoxSizer(sizer_encbox_staticbox, wxHORIZONTAL);
    wxGridSizer* grid_sizer_encodings = new wxGridSizer(4, 3, 0, 0);
    wxBoxSizer* sizer_conn = new wxBoxSizer(wxVERTICAL);
    wxStaticBoxSizer* sizer_multicast = new wxStaticBoxSizer(sizer_multicast_staticbox, wxVERTICAL);
    wxStaticBoxSizer* sizer_qos = new wxStaticBoxSizer(sizer_qos_staticbox, wxHORIZONTAL);
    wxStaticBoxSizer* sizer_fastrequest = new wxStaticBoxSizer(sizer_fastrequest_staticbox, wxVERTICAL);
    sizer_fastrequest->Add(checkbox_fastrequest, 0, wxALL|wxEXPAND, 3);
    sizer_fastrequest->Add(label_fastrequest, 0, wxALL, 3);
    sizer_fastrequest->Add(slider_fastrequest, 0, wxALL|wxEXPAND, 3);
    sizer_conn->Add(sizer_fastrequest, 0, wxALL|wxEXPAND, 3);
    sizer_qos->Add(checkbox_qos_ef, 0, wxALL|wxEXPAND, 3);
    sizer_conn->Add(sizer_qos, 0, wxALL|wxEXPAND, 3);
    sizer_multicast->Add(checkbox_multicast, 0, wxALL|wxEXPAND, 3);
    sizer_multicast->Add(label_socketrecvbuf, 0, wxALL, 3);
    sizer_multicast->Add(slider_socketrecvbuf, 0, wxALL|wxEXPAND, 3);
    sizer_multicast->Add(label_recvbuf, 0, wxALL, 3);
    sizer_multicast->Add(slider_recvbuf, 0, wxALL|wxEXPAND, 3);
    sizer_conn->Add(sizer_multicast, 0, wxALL|wxEXPAND, 3);
    notebook_settings_pane_conn->SetSizer(sizer_conn);
    grid_sizer_encodings->Add(checkbox_enc_copyrect, 0, wxALL, 3);
    grid_sizer_encodings->Add(checkbox_enc_hextile, 0, wxALL, 3);
    grid_sizer_encodings->Add(checkbox_enc_rre, 0, wxALL, 3);
    grid_sizer_encodings->Add(checkbox_enc_corre, 0, wxALL, 3);
    grid_sizer_encodings->Add(checkbox_enc_zlib, 0, wxALL, 3);
    grid_sizer_encodings->Add(checkbox_enc_zlibhex, 0, wxALL, 3);
    grid_sizer_encodings->Add(checkbox_enc_zrle, 0, wxALL, 3);
    grid_sizer_encodings->Add(checkbox_enc_zywrle, 0, wxALL, 3);
    grid_sizer_encodings->Add(checkbox_enc_ultra, 0, wxALL, 3);
    grid_sizer_encodings->Add(checkbox_enc_tight, 0, wxALL, 3);
    sizer_encbox->Add(grid_sizer_encodings, 1, 0, 3);
    sizer_encodings->Add(sizer_encbox, 0, wxALL|wxEXPAND, 3);
    sizer_tightsettings->Add(label_compresslevel, 0, wxALL, 3);
    sizer_tightsettings->Add(slider_compresslevel, 0, wxALL|wxEXPAND, 3);
    sizer_tightsettings->Add(label_quality, 0, wxALL, 3);
    sizer_tightsettings->Add(slider_quality, 0, wxALL|wxEXPAND, 3);
    sizer_encodings->Add(sizer_tightsettings, 0, wxALL|wxEXPAND, 3);
    notebook_settings_pane_encodings->SetSizer(sizer_encodings);
    sizer_logging->Add(checkbox_logfile, 0, wxALL, 6);
    sizer_logging->Add(checkbox_stats_save, 0, wxALL, 6);
    notebook_settings_pane_logging->SetSizer(sizer_logging);
    notebook_settings->AddPage(notebook_settings_pane_conn, _("Connections"));
    notebook_settings->AddPage(notebook_settings_pane_encodings, _("Encodings"));
    notebook_settings->AddPage(notebook_settings_pane_logging, _("Logging"));
    sizer_top->Add(notebook_settings, 1, wxALL|wxEXPAND, 3);
    SetSizer(sizer_top);
    sizer_top->Fit(this);
    Layout();
    // end wxGlade
}

